/*
** game.h
*/

#ifndef __GAME_H__
# define __GAME_H__

/*
** The following data type is used only to keep trace on the calculations
** done, in order to be displayed.
**
**     n1 op n2 = res
** Ex:  6  *  9 =  42 (no, there is not any errors (this is The Answer))
*/
typedef struct	s_calc
{
  unsigned	n1;
  char		op;
  unsigned	n2;
  unsigned	res;
}		t_calc;

/*
** res		Result to search
** l		Length of the 2 following dynamic array
** n		Numbers list
** u		"Used" flags, corresponding to the numbers list
** ncalc	Current number of calculations stored in the calcs array
** calcs	Calculations done (lengh of this array: game->l - 1)
** trycnt	"Try" counter
*/
typedef struct	s_game
{
  unsigned	res;
  unsigned	l;
  unsigned	*n;
  char		*u;
  unsigned	ncalc;
  t_calc	*calcs;
  unsigned	trycnt;
}		t_game;

int			game_init(t_game *game, int argc, char **argv);
unsigned		game_compute(t_game *game,
				     void (*show_solution)(t_game *));
unsigned	game_work_with_these_2nb(t_game *game,
					 void (*show_solution)(t_game *),
					 int n1_idx,
					 int n2_idx);
int			game_res_reached(t_game *game);
unsigned		game_nb_used_numbers(t_game *game);
void			game_free(t_game *game);

#endif /* !__GAME_H__ */
