/*
** main.c
*/

#include <stdio.h>
#include <game.h>
#include <main.h>

/*
** Entry point.
**
** Arguments:
**  argc		Arguments counter
**  argv		Arguments vector
**
** Return value:
**  0			Okay
**  1			Error
*/
int			main(int argc, char **argv)
{
  t_game		game;
  unsigned		nsol;

  if (0 > game_init(&game, argc, argv))
    {
      fprintf(stderr, "\"Le Compte Est Bon\"\n\n"
	      "Usage:\n\t%s res n0 [n1 [n2 [...]]]\n", argv[0]);
      return (1);
    }
  else
    {
      printf("-- Searching %i whith:", game.res);
      for (nsol = 0; nsol < game.l; nsol++)
	printf(" %i", game.n[nsol]);
      printf("\n");
      nsol = game_compute(&game, show_solution);
      printf("-- End of search (%u solutions / %u trycount).\n",
	     nsol, game.trycnt);
      game_free(&game);
      return (0);
    }
}

/*
** A pointer to this func is used to show a solution
**
** Arguments:
**  game		Structure containing all datas
*/
void			show_solution(t_game *game)
{
  unsigned		i;

  /* printf("(trycnt=%u):", game->trycnt); */
  if (!game->ncalc)
    printf(" <the result is in the numbers list>");
  else
    for (i = 0; i < game->ncalc; i++)
      printf(" %d %c %d = %d;", game->calcs[i].n1, game->calcs[i].op,
	     game->calcs[i].n2, game->calcs[i].res);
  printf("\n");
}
